/*Proc Aggregation Example*/

libname RDExamp "C:\users\sasdemo\RD_Examples";
%let test_lib = RDExamp;

/*- Aggregation Configuration Data Set ----------*/

data &test_lib..config;
length unit $32 region  $32 strategy $32 copula $32 marginal $32 var $32 group $32 REFNAME $32;
input unit $ region $ strategy $ copula $ marginal $ var $ group $ refname;
datalines;
FixedIncome + + copula1 nosrc PL group1 FITotal
Commodities + + copula1 nosrc PL group1 CommodTotal
Equity + + copula1 nosrc PL group1 EQTotal
FixedIncome London + copula2 nosrc PL group2 FILondon
FixedIncome NewYork + copula2 nosrc PL group2 FINewYork
FixedIncome Sydney + copula2 marg1 PL group2 FISydney
FixedIncome London LongTermFinancing copula3 marg2 PL group3 FILondonLTF
FixedIncome London ShortTermFinancing copula3 marg3 PL group3 FILondonSTF
FixedIncome NewYork LongTermFinancing copula4 marg4 PL group4 FINewYorkLTF
FixedIncome NewYork ShortTermFinancing copula4 marg5 PL group4 FINewYorkSTF
Commodities London + copula5 nosrc PL group5 CommodLondon
Commodities Houston + copula5 nosrc PL group5 CommodHouston
Commodities London Metals copula6 marg6 PL group6 CommodLondonMet
Commodities London Proprietary copula6 marg7 PL group6 CommodLondonProp
Commodities Houston Oil copula7 marg8 PL group7 CommodHoustonOil
Commodities Houston Energy copula7 marg9 PL group7 CommodHoustonEnergy
Equity London + copula8 marg10 PL group8 EQLondon
Equity NewYork + copula8 nosrc PL group8 EQNewYork
Equity NewYork Hedging copula9 marg11 PL group9 EQNewYorkHDG
Equity NewYork Proprietary copula9 marg12 PL group9 EQNewYorkProp
;
run;

data RDExamp.copula;
length name $32 parameter $32 CValue $32;
input name $ parameter $ CValue $ NValue;
datalines;
copula1 type t .
copula1 cov RDExamp.UnitCorr .
copula1 df . 10
copula2 type t .
copula2 cov RDExamp.FIRegionCorr .
copula2 df . 25
copula3 type clayton .
copula3 theta . 0.70
copula4 type clayton .
copula4 theta . 0.60
copula5 type frank .
copula5 theta . 1
copula6 type clayton .
copula6 theta . 65
copula7 type clayton .
copula7 theta . 4
copula8 type normal .
copula8 cov RDExamp.EQRegionCorr .
copula9 type Frank .
copula9 theta . .5
;
run;


/*- Marginal Specification Data Set --------------*/
data RDExamp.marginal;
length name $32 parameter $32 CValue $32;
input name $ parameter $ CValue $ NValue ;
datalines;
marg1 type NORMAL .
marg1 args . 2
marg1 parm . 1000
marg1 parm . 500000
marg2 type NORMAL .
marg2 args . 2
marg2 parm . 20000
marg2 parm . 450000
marg3 type NORMAL .
marg3 args . 2
marg3 parm . 1500
marg3 parm . 200000
marg4 type NORMAL .
marg4 args . 2
marg4 parm . 350
marg4 parm . 175000
marg5 type NORMAL .
marg5 args . 2
marg5 parm . 2150
marg5 parm . 150000
marg6 type NORMAL .
marg6 args . 2
marg6 parm . 53000
marg6 parm . 1000
marg7 type NORMAL .
marg7 args . 2
marg7 parm . 800
marg7 parm . 2000
marg8 type NORMAL .
marg8 args . 2
marg8 parm . 10
marg8 parm . 15000
marg9 type NORMAL .
marg9 args . 2
marg9 parm . 650
marg9 parm . 1800
marg10 type NORMAL .
marg10 args . 2
marg10 parm . 100
marg10 parm . 14000
marg11 type NORMAL .
marg11 args . 2
marg11 parm . 2300
marg11 parm . 1000
marg12 type EMPIRICAL .
marg12 source RDExamp.EQNewYorkProp .
;
run;


/*- Correlation Matrix for Units: Student T copula ---------*/
data RDExamp.UnitCorr;
length _name_ $12;
input _name_ $ _type_ $ FITotal CommodTotal EQTotal;
datalines;
FITotal     corr   1   .25   .35
CommodTotal corr  .25   1    .3
EQTotal     corr  .35  .3    1
;
run;

/*- Correlation Matrix for Regions in Fixed Income: Student T copula ---------*/
data RDExamp.FIRegionCorr;
length _name_ $12;
input _name_ $ _type_ $ FILondon FINewYork FISydney;
datalines;
FILondon      corr      1   .45   .40
FINewYork     corr     .45   1    .50
FISydney      corr     .40  .50    1
;
run;
/*- Correlation Matrix for Equities: Normal Copula -----------*/
data RDExamp.EQRegionCorr;
length _name_ $12;
input _name_ $ _type_ $ EQLondon EQNewYork;
datalines;
EQLondon  corr  1   .35
EQNewYork corr .35    1 
;
run;
data RDExamp.EQNewYorkProp;
format _date_ date9.;
length refname $32.;
input refname $ _date_ date9. replication PL;
datalines;

EQNewYorkProp 25MAY2011 1 956.72
EQNewYorkProp 29MAY2011 2 438.57
EQNewYorkProp 30MAY2011 3 564.76
EQNewYorkProp 31MAY2011 4 456.11
EQNewYorkProp 01JUN2011 5 229.23
EQNewYorkProp 04JUN2011 6 270.67
EQNewYorkProp 05JUN2011 7 1158.99
EQNewYorkProp 06JUN2011 8 408.93
EQNewYorkProp 07JUN2011 9 1207.44
EQNewYorkProp 08JUN2011 10 1535.40
EQNewYorkProp 11JUN2011 11 800.34
EQNewYorkProp 12JUN2011 12 1574.01
EQNewYorkProp 13JUN2011 13 689.35
EQNewYorkProp 14JUN2011 14 208.58
EQNewYorkProp 15JUN2011 15 -1307.27
EQNewYorkProp 18JUN2011 16 766.56
EQNewYorkProp 19JUN2011 17 231.87
EQNewYorkProp 20JUN2011 18 -277.57
EQNewYorkProp 21JUN2011 19 639.86
EQNewYorkProp 22JUN2011 20 926.39
;
run;



proc aggregation
vars =(pl comptype=pl)
ccv =(unit  region  strategy)
config_data = RDExamp.config
copula_spec= RDExamp.copula
marginal_spec= RDExamp.marginal
alpha=0.05
seed = 1234
ndraws = 100000
out_simdata = RDExamp.simdata
out_statdata = RDExamp.statdata
;
runaggr;
run;

